###########################
# BashOrg plugin by _vit
# This plugin you may use for fun:)
# Version 0.01
# 14.03.2008
###########################

package bashorg;
use strict;
use Plugins;
use Log qw(message debug error);
use Globals;
use Log qw(message warning error);
use LWP::Simple;
use I18N qw(bytesToString);

Plugins::register('bashorg', 'Talking random quote from http://bash.org.ru', \&on_unload, \&on_reload);

my $cmd = Commands::register(
    ["bash", "Talking random quote from http://bash.org.ru", \&quote],
);

sub on_unload {
    Commands::unregister($cmd);
}

sub on_reload {
}

sub quote {
    my (undef, $command) = @_;
    my @commands = split(/ /, $command); 
    my $quote = "";
	
	if ($command eq "" || $command eq "c" || $command eq "p" || $command eq "g" || $commands[0] eq "pm"){	
        $quote = get 'http://bash.org.ru/forweb/';
        $quote = bytesToString($quote);
        debug ("\n===== BEFORE =====\n" . $quote . "\n==================\n");

        # trim begin
        $quote =~ s/var borq='';//g;
        $quote =~ s/.+?approved by.*?</</g;
        
        # trim end
        $quote =~ s/document.write\(borq\);//g;
        $quote =~ s/.{30}<' \+ 'a href=.http:..bash.org.ru.+//g;
        
        # remove JavaScript code
        $quote =~ s/<' \+ '.*?>/\n/g;
        
        $quote =~ s/&quot;/"/g;
        $quote =~ s/&lt;(.*?)&gt;/$1/eg;
        $quote =~ s/\n\n\n/\n/g;
        $quote =~ s/\n\n/\n/g;
        
        debug ("\n===== AFTER =====\n" . $quote . "\n=================\n");
        
        my @lines = split(/\n/, $quote);
        
        for(my $i = 1; $i < scalar(@lines); $i++){
            if ($command eq ""){
                message("    " . $lines[$i] . "\n");
            }else{
                debug("Using command: $command $lines[$i]");
                Commands::run("$command $lines[$i]");
            }
            sleep(0.25);
        }
    }else{
         error("Syntax Error in function 'bash'\nUsage: bash <c|p|g|pm PlayerName>\n");
         error("Where:\n <c> - public chat\n <p> - party chat\n <g> - guild chat\n <pm PlayerName> - private message\n"); 
    }
}

return 1;